package com.qmth.themis.business.constant;

import com.qmth.themis.common.enums.Platform;
import com.qmth.themis.common.enums.Source;

import java.util.Objects;

/**
 * @Description: 系统常量
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2019/10/11
 */
public class SystemConstant {
    /**
     * 鉴权
     */
    public static final String TOKEN = "token";
    public static final String PLATFORM = "platform";
    public static final String DEVICE_ID = "deviceId";
    public static final String ROLE = "role";

    /**
     * 阿里云oss
     */
    public static final String END_POINT = "endpoint";
    public static final String ACCESS_KEY_ID = "accessKeyId";
    public static final String ACCESS_KEY_SECRET = "accessKeySecret";
    public static final String BUCKET = "bucket";

    /**
     * 系统相关
     */
    public static final String SUCCESS = "{'success':true}";
    public static final String RECORDS = "records";
    public static final String USER = "user_";
    public static final String SESSION = "session_";
    public static final String LINK = "LINK";
    public static final String MENU = "MENU";
    public static final String AUTH_CACHE = "auth_cache";
    public static final String ALL_PATH = "/**";

    public static final String JWT_USERID = "userId";
    public static final String JWT_SECRET = "YuiopB0009Xn";//jwt密钥
    public static final String JWT_CURRENT_TIME = "currentTimeMillis";
    public static final long JWT_WEB_EXPIRE_TIME = 60L * 1440L * 1000L;//过期时间24小时
    public static final long JWT_PC_EXPIRE_TIME = 60L * 1440L * 1000L;//过期时间24小时
    public static final long JWT_PAD_EXPIRE_TIME = 60L * 1440L * 1000L;//过期时间24小时
    public static final long JWT_PHONE_EXPIRE_TIME = 60L * 43200L * 1000L;//过期时间30天
    public static final long REDIS_EXPIRE_TIME = 60L * 1440L;//过期时间24小时
    public static final long REDIS_REFRESH_EXPIRE_TIME = 60L * 60L;//刷新时间1小时，理论上说24小时还不睡觉也已经快不行了
    public static final long REFRESH_EXPIRE_TIME = 60L * 5L;//过期剩余时间5分钟

    /**
     * 获取过期时间
     *
     * @param platform
     * @return
     */
    public static long expireTime(Platform platform) {
        Long expireTime = null;
        if (Objects.equals(platform.getSource(), Source.Web.name())) {
            expireTime = SystemConstant.JWT_WEB_EXPIRE_TIME;
        } else if (Objects.equals(platform.getSource(), Source.PC.name())) {
            expireTime = SystemConstant.JWT_PC_EXPIRE_TIME;
        } else if (Objects.equals(platform.getSource(), Source.Pad.name())) {
            expireTime = SystemConstant.JWT_PAD_EXPIRE_TIME;
        } else if (Objects.equals(platform.getSource(), Source.Phone.name())) {
            expireTime = SystemConstant.JWT_PHONE_EXPIRE_TIME;
        }
        return expireTime.longValue();
    }
}