package com.qmth.themis.business.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.themis.business.dao.TBSessionMapper;
import com.qmth.themis.business.entity.TBSession;
import com.qmth.themis.business.service.TBSessionService;
import com.qmth.themis.business.util.JwtUtil;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.Objects;

/**
 * @Description: 会话信息 服务实现类
 * @Param:
 * @return:
 * @Author: wangliang
 * @Date: 2020/6/25
 */
@Service
public class TBSessionServiceImpl extends ServiceImpl<TBSessionMapper, TBSession> implements TBSessionService {

    /**
     * 保存session信息
     *
     * @param o
     * @return
     */
    @Override
    public TBSession saveSessionInfo(Object... o) {
        String id = String.valueOf(o[0]);
        String type = String.valueOf(o[2]);
        String platform = String.valueOf(o[3]);
        String source = String.valueOf(o[4]);
        String deviceId = String.valueOf(o[5]);
        String token = String.valueOf(o[6]);
        String ip = String.valueOf(o[7]);
        QueryWrapper<TBSession> sqw = new QueryWrapper<>();
        sqw.lambda().eq(TBSession::getId, id).eq(TBSession::getType, type).eq(TBSession::getPlatform, platform);
        TBSession tbSession = this.getOne(sqw);
        if (Objects.isNull(tbSession)) {
            tbSession = new TBSession();
            tbSession.setId(id);
            tbSession.setIdentity(String.valueOf(o[1]));
            tbSession.setType(type);
            tbSession.setPlatform(platform);
            tbSession.setSource(source);
            tbSession.setDeviceId(deviceId);
            tbSession.setAccessToken(token);
            tbSession.setAddress(ip);
            tbSession.setLastAccessTime(new Date());
            tbSession.setUpdateTime(new Date());
            tbSession.setExpireTime(JwtUtil.getExpirationDateFromToken(token));
        } else {
            tbSession.setDeviceId(deviceId);
            tbSession.setAccessToken(token);
            tbSession.setLastAccessIp(ip);
            tbSession.setLastAccessTime(new Date());
            tbSession.setUpdateTime(new Date());
            tbSession.setExpireTime(JwtUtil.getExpirationDateFromToken(token));
        }
        this.saveOrUpdate(tbSession);
        return tbSession;
    }
}
