package com.qmth.themis.common.enums;

public enum Platform {

    SERVER("Server"), IOS("Phone"), Android("Phone"), WAP("Web"), Ipad("Pad"), Windows("PC"), Mac("PC");

    public static Platform findByName(String name) {
        if (name == null) {
            return null;
        }
        for (Platform item : Platform.values()) {
            if (item.toString().equalsIgnoreCase(name)) {
                return item;
            }
        }
        return null;
    }

    private String source;

    Platform(String source) {
        this.source = source;
    }

    public String getSource() {
        return source;
    }

    public boolean equals(String name) {
        return toString().equalsIgnoreCase(name);
    }
}
